﻿package{
	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	
	public class IntuitiveDrawer extends Sprite{
		
		var bg:BitmapData;
		
		var container:Bitmap;
		var line:Sprite;
		var linea:Sprite;
		var lineCopy:Sprite;
		var lineCopya:Sprite;
		var lineStack:Array;
		var lineStacka:Array;
		var matrix:Matrix;
		var matrixa:Matrix;
		
		public function IntuitiveDrawer():void{
			
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);

			container = new Bitmap(bg);
			
			addChild(container);
			
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessinea);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessinea);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessinea);
		
			}
			
		private function startDessine(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodit);
			matrix = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			line.graphics.lineStyle(1,0xcccccc,0.5);
			line.graphics.moveTo(e.stageX,e.stageY);
			lineStack.push(new Array(e.stageX,e.stageY));
			}
		
		private function dessine(e:MouseEvent):void{
			if(line != null){
				line.graphics.lineTo(e.stageX,e.stageY);
				lineStack.push(new Array(e.stageX,e.stageY));
				addChild(line);
				}
			}
		
		private function stopDessine(e:MouseEvent):void{
			if(line != null){
				removeChild(line);
				line = null;
				floodFill();
			}
		}
		////////////////////////////////////////////////////////////////////////////////////
		private function startDessinea(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodita);
			matrixa = new Matrix();
			linea = new Sprite();
			lineStacka = new Array();
			linea.graphics.lineStyle(1,0xcccccc,0.5);
			linea.graphics.moveTo(e.stageX,e.stageY);
			lineStacka.push(new Array(e.stageX,e.stageY));
			}
		
		private function dessinea(e:MouseEvent):void{
			if(linea != null){
				linea.graphics.lineTo(e.stageX,e.stageY);
				lineStacka.push(new Array(e.stageX,e.stageY));
				addChild(linea);
				}
			}
		
		private function stopDessinea(e:MouseEvent):void{
			if(linea != null){
				removeChild(linea);
				linea = null;
				floodFilla();
			}
		}
		
		////////////////////////////////////////////////////////////////////////////////////
		
		private function floodFill():void{
			lineCopy= new Sprite();
			lineCopy.graphics.lineStyle(1,buildColor(),0.3);
			lineCopy.graphics.moveTo(lineStack[0][0],lineStack[0][1]);
			for(var i:uint=1;i<lineStack.length;i++){
				lineCopy.graphics.lineTo(lineStack[i][0],lineStack[i][1]);
				}
			addEventListener(Event.ENTER_FRAME,floodit);
			}
		
		private function floodit(e:Event):void{
			matrix.scale(0.9999,1.005);
			matrix.translate(10, -10)
			matrix.rotate(10);
			bg.draw(lineCopy,matrix);
			}

		////////////////////////////////////////////////////////////////////////////////////

		private function floodFilla():void{
			lineCopya= new Sprite();
			lineCopya.graphics.lineStyle(0.3,buildcolor(),0.7);
			lineCopya.graphics.moveTo(lineStacka[0][0],lineStacka[0][1]);
			for(var i:uint=1;i<lineStacka.length;i++){
				lineCopya.graphics.drawRect(lineStacka[i][0],lineStacka[i][1],3,3);
				}
			addEventListener(Event.ENTER_FRAME,floodita);
			}
			
		private function floodita(e:Event):void{
			matrixa.scale(0.9999,1.005);
			matrixa.translate(7, -7);
			matrixa.rotate(8);
			bg.draw(lineCopya,matrixa);
			}
			
			
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():uint{
			var R:uint = Math.round(Math.random()*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var nbr:uint =  R << 16 | G << 8 | B;
			return nbr;
			}
			
		private function buildcolor():uint{
			var Ra:uint = Math.round(Math.random()*255);
			var Ga:uint = Math.round(Math.random()*255);
			var Ba:uint = Math.round(Math.random()*255);
			var nbra:uint =  Ra << 16 | Ga << 8 | Ba;
			return nbra;
			}
	}
	
}